;===============================================
;;; This is a preliminary release of the pmc engine from the 
;;; PWConstraints by Mikael Laurson (c), 1995
;;; 
;;; The pmc engine transported to OpenMusic 1999 (by rjan Sandred)
;;; 
;;; All copyright belongs to Mikael Laurson, who also is the author of 
;;; the code for this library.

;===============================================

;version 0.50 is the first version released on IRCAM Forumm CDrom
;version 0.53 adds a graphical interface for rules
;version 1.0 corrects a bug for the l variable (27/01/2004)
;version 1.01 corrects a bug in the index rule (function compile-pattern-matching-rule)
;version 1.02 updated the code to load properly in OM 6.12
;   Known issue: icons are not showing properly (default icon is used)


;--------------------------------------------------
(In-package :cl-user)
;(defvar omcs)
;(defpackage omcs)
;(in-package omcs)

 
;--------------------------------------------------
;Variable definiton with files to load 
;--------------------------------------------------


(defvar *omcs-source-dir* nil)
(setf *omcs-source-dir* (append (pathname-directory *load-pathname*) (list "sources")))


(defvar *OMCS-lib-files* nil)
(setf *OMCS-lib-files* '(
                          "OMConstraints-package"
                          "constraint-utilities"
;================================================================
; OMCs kernel
                          "constraint-diagnostics"  
                          "search-variable"
                          "search-engine"
                          "PM-compiler"
                          "forward-checking"
                          "OMCs-utilities-split1"
                          "Graphic-rule-interface"
; Added functions Sandred
                          ))

;--------------------------------------------------
;Loading files 
;--------------------------------------------------
;(if (om-standalone-p)
;   (mapc #'(lambda (file) (load (make-pathname :directory *omcs-source-dir* :name file))) *OMCS-lib-files*)
(mapc #'(lambda (file) (compile&load (make-pathname :directory *omcs-source-dir* :name file))) *OMCS-lib-files*)

(in-package omcs)

;--------------------------------------------------
; RC subpackages initialization
; ("sub-pack-name" subpacke-lists class-list function-list class-alias-list)
;--------------------------------------------------
(defvar *subpackages-list* nil)
(setf *subpackages-list*
      '(
        ("01-PMC" nil nil (pmc-engine) nil)
        ("02-RULES" nil nil (wildcard-rule index-rule) nil)
        ("03-TOOLS" nil nil (partial-solution rev-partial-solution current-index) nil)
        ))
;--------------------------------------------------
;filling packages
;--------------------------------------------------
(om::fill-library *subpackages-list*)



;ERRORS function while? in constraint-utilities.lisp, search-variable.lisp